package controller;

import javax.faces.bean.ManagedBean;
import javax.inject.Inject;

import model.Product;
import annotation.*;
import service.*;

@ManagedBean(name = "Index")
public class IndexController {

	/**
	 * 演示在私有成员上注入，以及一个接口多个实现时，利用自定义注解，匹配正确的注入类型
	 */
	@Inject
	@Book
	private ProductService bookProductService;

	@Inject
	@Telephone
	private ProductService telephoneProductService;
	
	@Inject
	@Cloth
	private ProductService clothProductService;

	public ProductService getBookProductService() {
		return bookProductService;
	}

	
	public ProductService getTelephoneProductService() {
		return telephoneProductService;
	}
	
	private Product product ;
	
	/**
	 * 演示在方法上使用@Inject注入
	 * @param p
	 */
	@Inject
	public void setProduct(Product p){
		product = p;		
	}
	
	public Product getProduct(){
		return product;		
	}


	public ProductService getClothProductService() {
		return clothProductService;
	}	

}
